/*
 * led.h
 *
 *  Created on: Jun 6, 2021
 *      Author: user
 */

#ifndef INC_LED_H_
#define INC_LED_H_

#include "stdint.h"
#include "stm32l0xx_hal.h"

/*
 * Context struct
 */

typedef struct {
	GPIO_TypeDef *red_led_port;
	int red_led_pin;
	GPIO_TypeDef *green_led_port;
	int green_led_pin;
	GPIO_TypeDef *blue_led_port;
	int blue_led_pin;

} led_context_t;

/*
 * Externally defined variables
 */

extern int led_pwm_max;
extern int led_pwm_counter;
extern int led_red_intensity;
extern int led_green_intensity;
extern int led_blue_intensity;

/*
 * Function prototypes
 */

void led_test();
void led_set_color(float red, float green, float blue);
// led_off(): turn off all LEDs
void led_off();
// led_pwm_handler(): handles switching LEDs on/off according to desired intensity;
// should be regularly called in timer routine, preferably in SysTick_Handler()
void led_pwm_handler();
void led_init(led_context_t *context, int pwm_freq, int pwm_handler_freq);
void led_test(int r, int g, int b);

#endif /* INC_LED_H_ */
